diff --git a/src/backend/optimizer/prep/preptlist.c b/src/backend/optimizer/prep/preptlist.c
index e9434580d6..895bcd5388 100644
--- a/src/backend/optimizer/prep/preptlist.c
+++ b/src/backend/optimizer/prep/preptlist.c
@@ -146,9 +146,8 @@ preprocess_targetlist(PlannerInfo *root)
 		char		resname[32];
 		TargetEntry *tle;
 
-		/* child rels use the same junk attrs as their parents */
-		if (rc->rti != rc->prti)
-			continue;
+		/* No child row marks yet. */
+		Assert (rc->rti == rc->prti);
 
 		if (rc->allMarkTypes & ~(1 << ROW_MARK_COPY))
 		{
